VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "IniFileClass"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
'############################### INI FILE CLASS ##############################
'# Description: This Class creates/reads and writes to an INI file           #
'#              It simplifies the addition of INI files to your project      #
'#                                                                           #
'#  CLASS  :IniFileClass.cls                                                 #
'#  Version: 1.0   Version Date 9/5/1999                                     #
'#  Author : N Mmichael                                                      #
'#                                                                           #
'#############################################################################

Option Explicit 'It is a good practice to declare variables before using them

'-----------------Declaration of Class Members follow-------------------------

'=================== (Private or Hidden) Properties========================================
'Inorder to have high security the properties are made non accessable (private)

Private nMode As Integer ' to select read write binary random sequential file opening
Private bErrorMsgbox As Boolean ' to select to message box on error if this is true

Private bUserAbort As Boolean 'To allow users to abort your program
Private nErrorcode As Integer 'the error code of I/O errors held here
Private sErrortext As String 'The description if of I/O errors held here
Private nFileNum As Integer 'The current file tag number
Private nLoopCnt As Integer 'number of retries before prompting user

Private sIniText() As String 'Array that stores Text file names to be written to INI File
Private sIniDescription() As String 'Array that stores Descriptions of above files(names)
Private nNrIniLines As Integer 'The number of lines to write/(read from) to ini file
Private sIniFileName As String 'The name of the ini file to write/read
Private nIniFileNum As Integer 'Tag number of ini file
Private bIniFileOpen As Boolean 'to confirm if ini file is open

'===========================Methods==============================================


 Public Sub SetIniFileName(IniFileName As String) 'set the file name of ini file
       sIniFileName = IniFileName
 End Sub
 
Public Sub OpenIniFile(Mode As String) ' (Mode is "read" or "write")  to  open ini file
       Dim iRetcode As Integer 'code returned by error handler
              
       nIniFileNum = FreeFile   ' Get unused file tag
       
       On Error GoTo ErrorLoop
       
       If Mode = "read" Then
              Open sIniFileName For Input As #nIniFileNum
       End If
       
       If Mode = "write" Then
              Open sIniFileName For Output Shared As #nIniFileNum
       End If
       
       
       bIniFileOpen = True
       Exit Sub
        
ErrorLoop:

        iRetcode = ErrorHandler
        
        If iRetcode = 3 Then
          If bUserAbort = True Then End
        End If
        
        If iRetcode = 4 Then
          Resume
        End If
        
        If iRetcode = 5 Then
          Resume Next
        End If
        
        bIniFileOpen = False
End Sub


Public Sub CloseIniFile() ' to close the ini file
       Dim iRetcode As Integer

       On Error GoTo ErrorLoop
       If bIniFileOpen = False Then Exit Sub
       Close #nIniFileNum
       bIniFileOpen = False
       Exit Sub
        
ErrorLoop:
        iRetcode = ErrorHandler
        
        If iRetcode = 3 Then
          If bUserAbort = True Then End
        End If
        
        If iRetcode = 4 Then
          Resume
        End If
        
        If iRetcode = 5 Then
          Resume Next
        End If
     
End Sub
 
  
 Public Sub WriteIniLine(sString As String) 'this write a string to ini file with error handling
     Dim iRetcode As Integer
     
       If bIniFileOpen = False Then Exit Sub
       nLoopCnt = 0
       On Error GoTo ErrorLoop
       Print #nIniFileNum, sString
       Exit Sub
       
ErrorLoop:
        iRetcode = ErrorHandler
        
        If iRetcode = 3 Then
          If bUserAbort = True Then End
        End If
        
        If iRetcode = 4 Then
          Resume
        End If
        
        If iRetcode = 5 Then
          Resume Next
        End If
        
End Sub


Public Function ReadIniLine() As String ' read a line from ini file and return it
  Dim iRetcode As Integer
  Dim sTemp As String
     
       If bIniFileOpen = False Then Exit Function
       nLoopCnt = 0
       sTemp = ""
       On Error GoTo ErrorLoop
       Line Input #nIniFileNum, sTemp
'       Input #nIniFileNum, sTemp
       ReadIniLine = sTemp
       Exit Function
        
ErrorLoop:
        iRetcode = ErrorHandler
        
        If iRetcode = 3 Then
          If bUserAbort = True Then End
        End If
        
        If iRetcode = 4 Then
          Resume
        End If
        
        If iRetcode = 5 Then
          Resume Next
        End If
        
End Function

'To load the arrays text & description for writing to ini file
Public Sub LoadIniTextArray(sString As String, Description As String, IniLineNr As Integer)

       If IniLineNr > nNrIniLines Then
              nNrIniLines = IniLineNr
              ReDim Preserve sIniText(nNrIniLines)
              ReDim Preserve sIniDescription(nNrIniLines)
       End If
       sIniText(IniLineNr) = sString
       sIniDescription(IniLineNr) = Description
End Sub

'To return the content of arrays ini text  after reading ini file
Public Function GetIniText(ByVal IniLineNr As Integer) As String
       GetIniText = sIniText(IniLineNr)
End Function


'To return the content of arrays  description after reading ini file

Public Function GetIniDescription(ByVal IniLineNr As Integer) As String
       GetIniDescription = sIniDescription(IniLineNr)
End Function

' To return the number of lines read into the arrays text & description after reading the ini file
Public Function GetNrLinesLoaded() As Integer
       GetNrLinesLoaded = UBound(sIniText)
End Function

Public Sub WriteIniFile() ' To write the arrays text & description to the ini file
       Dim i As Integer
       
       OpenIniFile ("write")
       nNrIniLines = UBound(sIniText)
       For i = 1 To nNrIniLines
              If Len(sIniText(i)) + Len(sIniDescription(i)) > 1 Then
                     If Len(sIniDescription(i)) > 1 Then
                            If Left(sIniDescription(i), 1) <> ";" Then
                                   WriteIniLine ";" & sIniDescription(i) & Chr(13)
                            Else
                                   WriteIniLine sIniDescription(i) & Chr(13)
                     
                            End If
                     Else
                            WriteIniLine ";" & sIniDescription(i) & Chr(13)
                     
                     End If
                     WriteIniLine sIniText(i) & Chr(13)
              End If
       Next i
       CloseIniFile
End Sub


Public Sub ReadIniFile() ' To read and load the arrays text & description from the ini file
       Dim sString As String
       Dim i As Integer
       
       
       ReDim sIniText(0)
       ReDim sIniDescription(0)
       
       OpenIniFile ("read")
       
       While Not EOF(nIniFileNum)
               
              
              If Not EOF(nIniFileNum) Then sString = ReadIniLine
              
              If Len(sString) > 0 Then
                     If Left(sString, 1) = ";" Then
                            ReDim Preserve sIniDescription(UBound(sIniDescription) + 1)
                            sIniDescription(UBound(sIniDescription)) = sString
                     Else
                            ReDim Preserve sIniText(UBound(sIniText) + 1)
                            sIniText(UBound(sIniText)) = sString
                     End If
              End If
       Wend
       
       If UBound(sIniText) <= 20 Then
               nNrIniLines = UBound(sIniText)
       Else
               nNrIniLines = 20
       End If
       For i = 1 To nNrIniLines
          Debug.Print "________________READ__INI__FILE_________________________________"
          Debug.Print "Line "; i
          Debug.Print "Descr "; sIniDescription(i)
          Debug.Print "Text File "; sIniText(i)
          Debug.Print "============================"
       Next i
       CloseIniFile
End Sub


' Allow the user to choose abort the program of file I/O errors
Public Sub AlowUserAbort(bYes As Boolean)
    bUserAbort = bYes
End Sub

Public Sub SetErrorMode(bYes As Boolean) 'your application passes error messagebox  flag
    bErrorMsgbox = bYes 'True will  select to message box on error if this is true
End Sub

Public Function ReturnErrorCode() As Integer
     ReturnErrorCode = nErrorcode 'Return the I/O error code to your application
End Function

Public Function ReturnErrortext() As String
     ReturnErrortext = sErrortext 'Return the I/O error text to your application
End Function

Public Sub ErrorMsgbox() ' if  bErrorMsgbox = bYes =="True" will  select to message box on error calling this function
          MsgBox ("File I/O  Error " & nErrorcode & "  " & sErrortext)
End Sub

Public Sub ShowStatus() ' Show the Status of the Class (object) in a message box
    MsgBox "Current Mode=" & nMode & Chr(13) & _
    "File is INI open =" & bIniFileOpen & Chr(13) & _
    "Current File Handle = #" & nFileNum & _
    "Display error message boxes=" & bErrorMsgbox & Chr(13) & _
    "I/O Error Code =" & nErrorcode & Chr(13) & _
    "I/O Error = " & sErrortext
End Sub

Public Function ErrorHandler() As Integer 'returns valu based on

          'vbAbort  3   Abort button pressed
          'vbRetry  4   Retry button pressed
          'vbIgnore 5   Ignore button pressed
            
          Const nErrorTimeOut = 6 'repeat error handler 6 times before prompting user
        
          Dim iError As Integer 'get users input for error message box (retry abort ignore)
          Dim sError As String 'the I/O error description
          Dim iReturnCode  ' the return code of this function
        
          Debug.Print Err.Number
          Debug.Print Err.Description
          Debug.Print nLoopCnt

          nErrorcode = Err.Number 'Storing error code to Property
          sErrortext = Err.Description 'Storing error text to Property
          iReturnCode = 0
         
          If bErrorMsgbox = True Then ErrorMsgbox
          sError = "File I/O   Error " & Err.Number & " " & Err.Description
         
          'MsgBox (Err.Description)
          'MsgBox ("Loop=" & Str(nLoopCnt))
        
          If bErrorMsgbox = True Then
        
               iError = MsgBox(sError, vbAbortRetryIgnore, "File I/O   Error ")
                        
               If iError = 3 Then 'abort
                    iReturnCode = 3
               End If
            
               If iError = 4 Then 'retry
                    iReturnCode = 4
               End If
            
               If iError = 5 Then 'ignore
                    iReturnCode = 5
               End If
          Else
               iReturnCode = 1 'ie user not prompted for error
          End If
        
          ErrorHandler = iReturnCode
          
End Function


Private Sub Class_Initialize() 'My Classes  (C++) constructor function
'                               To set the default values for private Properties

     bUserAbort = True 'allow user to abort program
     bErrorMsgbox = False ' to select to message box on error if this is true
     nErrorcode = 0 'Storing error code to Property
     sErrortext = "Sucessfull" 'Storing error text to Property
     bUserAbort = True 'allow user to abort program
     bIniFileOpen = False 'To tell me that a file has been opened
     bUserAbort = True ' to select to message box on error if this is true
     nErrorcode = 0 'Storing error code to Property
     sErrortext = "Sucessfull" 'Storing error text to Property
     ReDim sIniText(5)
     ReDim sIniDescription(5)
     nNrIniLines = 1
     
End Sub

Private Sub Class_Terminate() 'My Classes  (C++) destructor function
     If bIniFileOpen = True Then 'If ini file is still open close it
       Close #nIniFileNum
     End If
End Sub

'    Examples of how to use this class to read or write to the ini file
'
'       Public Sub SaveIniFile()
'
'              Dim i As Integer
'
'              Dim fIni As IniFileClass
'              Set fIni = New IniFileClass
'
'              fIni.SetIniFileName sIniFileName
'
'              For i = 1 To nNrFiles
'                     fIni.LoadIniTextArray sFileNames(i), sFileDescription(i), i
'              Next i
'
'              fIni.WriteIniFile
'       End Sub
'
'       Public Sub LoadIniFile()
'
'              Dim i As Integer
'
'              Dim fIni As IniFileClass
'              Set fIni = New IniFileClass
'
'              fIni.SetIniFileName sIniFileName
'
'              fIni.ReadIniFile
'              nNrFiles = fIni.GetNrLinesLoaded
'              For i = 1 To nNrFiles
'                     sFileNames(i) = fIni.GetIniText(i)
'                     sFileDescription(i) = fIni.GetIniDescription(i)
'              Next i
'       End Sub
